#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR DATA FILES  

#use FindBin;
#use lib $FindBin::Bin;
use CGI::Carp qw(fatalsToBrowser);  
use CGI;
use DBI;
use acs;
use psfp;
use Time::Local; 
use obbuild;

$default_permissions = 0777;

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES 

##################################################################################

if ($q->param('fct') eq "") {&start;}
if ($q->param('fct') eq "move_operation") {&move_operation;}
if ($q->param('fct') eq "delete_listings") {&delete_listings;}

##################################################################################

sub copy_links
{

my ($email_stat) = @_;


$pstring = "$admin_url/admin5.cgi?opaction=Copy&fct=link_functions&";

for ($ms = 0; $ms < $itemnrs; $ms++)
	{
	$cname = "C" . $ms;
	
	if ($q->param($cname) ne "")
		{
		($lnkid, $cid, $rid) = &decode_subm_data($q->param($cname));
		$pstring = $pstring . "$cname=$lnkid&";
		}
	}

$pstring = $pstring . "nr_links=$itemnrs&copy=true";

#print "Content-type: text/html\n\n";
print "Location: $pstring\n\n";

}




sub move_operation
{

print "Content-type: text/html\n\n";

### GET ALL CATEGORIES TO PREPARE LINK NUMBER UPDATE

$links_to_move = $q->param('links_to_move');
@all_links = split(/-/, $links_to_move);

$lnknumber = @all_links;

foreach $item (@all_links)
	{
	$sql_str = $sql_str . "(B.lnkid = '$item') OR ";
	}
	
$sql_str = substr($sql_str, 0, length($sql_str) - 3);

### GET CATEGORY NAMES TO UPDATE CATEGORY NUMBERS

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

$sql = "SELECT A.cid, A.l1, A.l2, A.l3, A.l4, A.l5, A.l6, A.l7, A.l8, A.l9, A.l10, A.l11, A.l12, A.l13, A.l14, A.l15, A.l16,
					B.lnkid 
					FROM dirs AS A, links AS B WHERE ($sql_str) AND (A.cid = B.cid)";

$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}

$nrcounter = 0;
while ( @row = $sth->fetchrow() )
	{
		
		$cats = "";
		for ($ms = 1; $ms < 17; $ms++) 
				{
				if ($row[$ms] ne "")
					{
					$cats = $cats . $row[$ms] . "::-::";
					}
				} 
		$cats = substr($cats, 0, length($cats) - 5);
			
	$move_crit[$nrcounter] = $row[17] . "--oo--" . $cats;
	$nrcounter++;
	
	$to_gen = $to_gen . $row[0] . ":\n"; ### GET CATEGORIES IDs WHERE LINKS ARE MOVED FROM
	} 



### UPDATE LINK NUMBERS IN CATEGORIES

$gcntr = 0;
foreach $item (@move_crit)
	{
	#print $item . "<BR>";
	
	($the_lnkid, $thecat) = split (/--oo--/, $item);
	
		my @allcats = split (/::-::/, $thecat);
			
			$cnc = 1; $sqlcrit = "";
			foreach $catitem (@allcats)
				{
				$catitem =~ s/'/\\'/g;  
				
				$sqlcrit = $sqlcrit . "(l" . $cnc . " = '$catitem') AND ";
				
				$all_updates[$gcntr] = $sqlcrit . "(l" . ($cnc+1) . " = '')";
				
				$gcntr++;
				
				$cnc++;
				}
	
	}


### UPDATE CATEGORY NUMBERS (MAKE NUMBERS LESS FROM THE CATEGORIES WHERE LINKS ARE MOVED OUT)

foreach $item (@all_updates)
	{
	$sql = "UPDATE dirs SET linknrs = linknrs - 1 WHERE $item";
	
	#print $sql . "<BR><BR>";

	$sth = $dbh->prepare($sql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
	}


### MOVE LINKS

$movecat = $q->param('movecat');
($move_to_cat, $tmp) = split (/___MVSPLT___/, $movecat);


foreach $item (@all_links)
	{
	$sql_str2 = $sql_str2 . "(lnkid = '$item') OR ";
	}
$sql_str2 = substr($sql_str2, 0, length($sql_str2) - 3);


$sql = "UPDATE links SET cid = '$move_to_cat' WHERE $sql_str2";

#print "<BR><BR><BR>$sql<BR><BR><BR>";

$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}


### UPDATE LINK NUMBERS IN NEW CATEGORY TO WHERE THE LINKS WAS MOVED (ADD LINK NUMBERS)

$sql = "SELECT * FROM dirs WHERE (cid='$move_to_cat')";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}

while ( @row = $sth->fetchrow() )
	{

	$fcats = "";
	for ($ms = 2; $ms < 18; $ms++) 
			{
			if ($row[$ms] ne "")
				{
				$fcats = $fcats . $row[$ms] . "::-::";
				}
			} 
	
	} 

$fcats = substr($fcats, 0, length($fcats) - 5);

@acat = split (/::-::/,$fcats);

$lcn = 1;
$cats_count = 0;
foreach $citem (@acat)
	{
	$citem =~ s/'/\\'/g;  
	$sqlq_str = $sqlq_str . "(l" . $lcn . " = '$citem') AND ";
	
	$cats_to_update[$cats_count] = $sqlq_str . "(l" . ($lcn+1) . " = '') ";
	$cats_count++;
	
	$lcn++;
	}

foreach $cat_item (@cats_to_update)
	{
	$sql = "UPDATE dirs SET linknrs = linknrs + $lnknumber WHERE $cat_item";
	$sth = $dbh->prepare($sql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
	
	#print $sql . "<BR><BR>";
	
	}

$sth->finish;
$dbh->disconnect; 

#### UPDATE CHANGE FILE SO THAT ONLY CHANGED HTML FILES CAN BE GENERATED

open (CH, ">> $data_dir/changed_cats.dat");
print CH $to_gen;
print CH $move_to_cat . ":\n";
close (CH);


$hbox = acs::get_heading_box("$web_url/add.gif", "Move Complete", qq[The listing(s) was moved.<BR><BR>
You may <a href="javascript:onClick=window.close()"><b>close</b></a> this window.]);



print qq[
<html>

<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>

<body onUnload="opener.location.reload(true);">

$hbox

</body>
</html>
];



}





sub delete_listings
{
print "Content-type: text/html\n\n";


### GET ALL CATEGORIES TO PREPARE LINK NUMBER UPDATE

$links_to_move = $q->param('links');
@all_links = split(/-/, $links_to_move);


$lnknumber = @all_links;

foreach $item (@all_links)
	{
	
	$fname1 = "$web_dir/imagefiles/$item" . ".gif";
	$fname2 = "$web_dir/imagefiles/$item" . ".jpg";
	if ((-e $fname1) > 0) { unlink ($fname1); }
	if ((-e $fname2) > 0) { unlink ($fname2); }
	
	$sql_str = $sql_str . "(B.lnkid = '$item') OR ";
	}
	
$sql_str = substr($sql_str, 0, length($sql_str) - 3);

### GET CATEGORY NAMES TO UPDATE CATEGORY NUMBERS

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

$sql = "SELECT A.cid, A.l1, A.l2, A.l3, A.l4, A.l5, A.l6, A.l7, A.l8, A.l9, A.l10, A.l11, A.l12, A.l13, A.l14, A.l15, A.l16,
					B.lnkid 
					FROM dirs AS A, links AS B WHERE ($sql_str) AND (A.cid = B.cid)";

$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}

$nrcounter = 0;
while ( @row = $sth->fetchrow() )
	{
		
		$cats = "";
		for ($ms = 1; $ms < 17; $ms++) 
				{
				if ($row[$ms] ne "")
					{
					$cats = $cats . $row[$ms] . "::-::";
					}
				} 
		$cats = substr($cats, 0, length($cats) - 5);
			
	$move_crit[$nrcounter] = $row[17] . "--oo--" . $cats;
	$nrcounter++;
	$to_gen = $to_gen . $row[0] . ":\n"; ### GET CATEGORIES IDs WHERE LINKS ARE MOVED FROM
	} 


### UPDATE LINK NUMBERS IN CATEGORIES

$gcntr = 0;
foreach $item (@move_crit)
	{
	#print $item . "<BR>";
	
	($the_lnkid, $thecat) = split (/--oo--/, $item);
	
		my @allcats = split (/::-::/, $thecat);
			
			$cnc = 1; $sqlcrit = "";
			foreach $catitem (@allcats)
				{
				$catitem =~ s/'/\\'/g;  
				
				$sqlcrit = $sqlcrit . "(l" . $cnc . " = '$catitem') AND ";
				
				$all_updates[$gcntr] = $sqlcrit . "(l" . ($cnc+1) . " = '')";
				
				$gcntr++;
				
				$cnc++;
				}
	
	}


### UPDATE CATEGORY NUMBERS (MAKE NUMBERS LESS FROM THE CATEGORIES WHERE LINKS ARE MOVED OUT)

foreach $item (@all_updates)
	{
	$sql = "UPDATE dirs SET linknrs = linknrs - 1 WHERE $item";
	
	#print $sql . "<BR><BR>";

	$sth = $dbh->prepare($sql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
	}



foreach $ditem (@all_links)
	{
	$sql_str2 = $sql_str2 . " (lnkid = '$ditem') OR";
	}
	$sql_str2 = substr($sql_str2, 0, length($sql_str2) -2);


$sql = "DELETE FROM links WHERE $sql_str2";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}

$sth->finish;
$dbh->disconnect; 


open (CH, ">> $data_dir/changed_cats.dat");
print CH $to_gen;
close (CH);



######################


$hbox = acs::get_heading_box("$web_url/ic_exclamation.gif", "Listing(s) Deleted", qq[
You may <a href="javascript:onClick=window.close()">close</a> this window.
]);


print qq[

<html>

<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>

<body onUnload="opener.location.reload(true);">

$hbox
</body>
</html>


];


}




sub delete_links
{

print "Content-type: text/html\n\n";

$itemnrs = $q->param('itemnrs');

$snr = 0;
for ($ms = 0; $ms < $itemnrs; $ms++)
	{
	$snr++;
	$vname = "C" . $ms;
	
	if ($q->param($vname) ne "")
		{
		($linkid, $tmpc) = split (/-/, $q->param($vname));
		$selected_items = $selected_items . $linkid . "-";
		}
	}

$selected_items = substr($selected_items, 0, length($selected_items) - 1);


if ($snr == 0) 
{
acs::problem_popup("You have to select at least one listing.");
exit;
}






$hbox = acs::get_heading_box("$web_url/ic_exclamation.gif", "Delete Listing(s)", qq[
<form method="POST" action="$admin_url/admin56.cgi">
  <input type="hidden" name="fct" value="delete_listings"><input type="hidden" name="links"
  value="$selected_items"><strong><p></strong>Are you sure you want to delete the selected
  listings?<strong> </strong><input type="submit" value="   Yes   " name="B1"> <input
  type="button" value="   No   " name="B2" onclick="window.close(); return false;"></p>
</form>
]);


print qq[
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" /> 
</head>
<body>
$hbox
</body>
</html>
];

}





sub start
{

$itemnrs = $q->param('itemnrs');
$itemnrs++;

if ($q->param('dropdown') eq "Edit"){&edit_links; exit;}
if ($q->param('dropdown') eq "Move"){&move_links; exit;}
if ($q->param('dropdown') eq "Delete"){&delete_links; exit;}
if ($q->param('dropdown') eq "Copy"){&copy_links; exit;}

}





sub edit_links
{

$pstring = "$admin_url/admin5.cgi?opaction=Edit&fct=link_functions&";
$itemnrs = 1;

for ($ms = 0; $ms < $q->param('itemnrs'); $ms++)
	{
	$cname = "C" . $ms;
	
	if ($q->param($cname) ne "")
		{
		($lnkid, $cid, $rid) = &decode_subm_data($q->param($cname));
		$pstring = $pstring . "$cname=$lnkid&";
		}
	$itemnrs++;
	}

$pstring = $pstring . "nr_links=$itemnrs";

print "Content-type: text/html\n\n";
print qq[<html>
<head>
<title>FocalMedia.Net Support</title>
<meta HTTP-EQUIV="REFRESH" CONTENT="0;URL=$pstring">
</head>
<body>
</body>
</html>];


#print "Location: $pstring\n\n";


}



sub move_links
{

my ($email_stat) = @_;

if ($email_stat eq "EMAIL")
	{
	$eml = "email=true";
	}

$pstring = "$admin_url/admin5.cgi?opaction=Move&fct=link_functions&";

for ($ms = 0; $ms < $itemnrs; $ms++)
	{
	$cname = "C" . $ms;
	
	if ($q->param($cname) ne "")
		{
		($lnkid, $cid, $rid) = &decode_subm_data($q->param($cname));
		$pstring = $pstring . "$cname=$lnkid&";
		}
	}

$pstring = $pstring . "nr_links=$itemnrs&newsub=other";

#print "Content-type: text/html\n\n";
print "Location: $pstring\n\n";

}



sub decode_subm_data
{
my ($submdat) = @_;

my ($item_nr, @ntit, $lnkid0, $ms0, $rid0, $cid0);

@ntit = split (/-/, $submdat);
$item_nr = @ntit;
$lnkid0 = $ntit[0];

for ($ms0 = 1; $ms0 < $item_nr; $ms0++)
	{
	$rid0 = 	$rid0 . $ntit[$ms0] . "-";
	}

$rid0 = substr($rid0, 0, length($rid0) - 1);

$cid0 = $ntit[$item_nr - 1];

return ($lnkid0, $cid0, $rid0);

}






sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

